PROGRAM MagicMazeTools;
USES FastVGA,PCXUnit;
CONST Back = 29; SSpr = 57;
 GameName = 'kd_game\MM_';
 SprBufSIze = 1030;

TYPE ByteArray = ARRAY[0..65534] of Byte;

VAR p : ^ByteArray;
 fil : File;
 i,x,y:Integer;
 pal:PaletteType;
BEGIN

 GoVGA256;

 GetMem(p,SPrBufSize);
 Assign(fil,GameName+'spr.dat');
 Rewrite(fil,1);

 LoadPCXPage2(GameName+'sspr.pcx',pal);     {Load special sprites}
 CopyFromPage2;
 BlockWrite(fil,pal,768); {Palette}
 FOR i:=0 TO SSpr DO
 BEGIN
	{GetMem(p,SprBufSize);    }
	x:=(i MOD 10)*32;    y:=(i div 10)*32;
	GetImage(x,y,x+31,y+31,p^);
   BlockWrite(fil,p^,SprBufSize);
 END;

 LoadPCX(GameName+'bspr.pcx');     {Load wall/floor sprites}
 FOR i:=0 TO Back DO
 BEGIN
	{GetMem(p,SPrBufSize); }
	x:=(i MOD 10)*32;    y:=Trunc(i/10)*32;
	GetImage(x,y,x+31,y+31,p^);
    BlockWrite(fil,p^,SprBufSize);
 END;

 Close(fil);
 Writeln('Bye!');
END.